﻿using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;
using System.Windows.Forms;
using System.Data;
using System.Data.OleDb;
using System.Data.Common;
using System.Globalization;
using System.Threading;
using Ofis;


namespace OFIS_2._0
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
    {
        OfisMain axOfisMain2 = new OfisMain();
        internal System.Windows.Forms.TextBox txtStrEnc;
		internal System.Windows.Forms.Label Label5;
		internal System.Windows.Forms.Label Label4;
		internal System.Windows.Forms.Label Label3;
        internal System.Windows.Forms.Button btnInit;
		internal System.Windows.Forms.Button btnSaveBmp;
        internal System.Windows.Forms.Button btnSaveJpg;
		internal System.Windows.Forms.Button btnVerify;
        internal System.Windows.Forms.Button btnRegister;
        private Button btnOK;
		internal System.Windows.Forms.Label Label2;
		internal System.Windows.Forms.TextBox edtUserName;
		internal System.Windows.Forms.Label Label1;
		//private AxOfis.AxOfisMain OfisMain;
		private System.Windows.Forms.SaveFileDialog SaveFileDialog1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.OpenFileDialog OpenFileDialog1;
		private string g_sFgr1, g_sFgr2, g_sFPVer = "9";
		internal System.Windows.Forms.Label label6;
		private System.Windows.Forms.TextBox edt1to1;
		private System.Windows.Forms.Button btnGet1to1;
        //private AxOfis.AxOfisMain axOfisMain1;
		private System.Windows.Forms.Button btnSet1to1;
        private Label lblFingerIndexResult;
        private Label lblFPVer;
        private RadioButton rdbnine;
        private RadioButton rbdten;
        private Button btnSetLanguage;
        private ComboBox cboSetLanguage;
        private Button btnRegTplFromFile;
        private Button btnVerTplFromFile;
        private TextBox txtKey;
        private Label lblDPI;
        private TextBox txtDPI;
        private Label lblDPI1;
        private TextBox txtDPI1;
        private Button btnPlayBeep;
        private Button btnPlayGreen;
        private Button btnPlayRed;
        private Microsoft.VisualBasic.PowerPacks.ShapeContainer shapeContainer1;
        private Microsoft.VisualBasic.PowerPacks.LineShape lineShape1;
        private Button btnAddTempIntoBuffer;
        private Button btnIdentifyFromBuffer;
        private Label lblUsernameBuffer;
        private TextBox txtUsernameBuffer;
        private Label lblUserIdBuffer;
        private TextBox txtUserIdBuffer;
        private Button btnRegTempIntoBuffer;
        private Button btnRemoveIdFromBuffer;
        private Button btnEncrypt;
        private Button btnDecrypt;
        private TextBox txtStrDec;
        private ListBox listBox1;
        private Int32 FHandle;


        public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
            
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.txtStrEnc = new System.Windows.Forms.TextBox();
            this.Label5 = new System.Windows.Forms.Label();
            this.Label4 = new System.Windows.Forms.Label();
            this.Label3 = new System.Windows.Forms.Label();
            this.btnInit = new System.Windows.Forms.Button();
            this.btnSaveBmp = new System.Windows.Forms.Button();
            this.btnSaveJpg = new System.Windows.Forms.Button();
            this.btnVerify = new System.Windows.Forms.Button();
            this.btnRegister = new System.Windows.Forms.Button();
            this.btnOK = new System.Windows.Forms.Button();
            this.Label2 = new System.Windows.Forms.Label();
            this.edtUserName = new System.Windows.Forms.TextBox();
            this.Label1 = new System.Windows.Forms.Label();
            this.SaveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
            this.OpenFileDialog1 = new System.Windows.Forms.OpenFileDialog();
            this.label6 = new System.Windows.Forms.Label();
            this.edt1to1 = new System.Windows.Forms.TextBox();
            this.btnGet1to1 = new System.Windows.Forms.Button();
            this.btnSet1to1 = new System.Windows.Forms.Button();
            this.lblFingerIndexResult = new System.Windows.Forms.Label();
            this.lblFPVer = new System.Windows.Forms.Label();
            this.rdbnine = new System.Windows.Forms.RadioButton();
            this.rbdten = new System.Windows.Forms.RadioButton();
            this.btnSetLanguage = new System.Windows.Forms.Button();
            this.cboSetLanguage = new System.Windows.Forms.ComboBox();
            this.btnRegTplFromFile = new System.Windows.Forms.Button();
            this.btnVerTplFromFile = new System.Windows.Forms.Button();
            this.txtKey = new System.Windows.Forms.TextBox();
            this.lblDPI = new System.Windows.Forms.Label();
            this.txtDPI = new System.Windows.Forms.TextBox();
            this.lblDPI1 = new System.Windows.Forms.Label();
            this.txtDPI1 = new System.Windows.Forms.TextBox();
            this.btnPlayBeep = new System.Windows.Forms.Button();
            this.btnPlayGreen = new System.Windows.Forms.Button();
            this.btnPlayRed = new System.Windows.Forms.Button();
            this.shapeContainer1 = new Microsoft.VisualBasic.PowerPacks.ShapeContainer();
            this.lineShape1 = new Microsoft.VisualBasic.PowerPacks.LineShape();
            this.btnAddTempIntoBuffer = new System.Windows.Forms.Button();
            this.btnIdentifyFromBuffer = new System.Windows.Forms.Button();
            this.lblUsernameBuffer = new System.Windows.Forms.Label();
            this.txtUsernameBuffer = new System.Windows.Forms.TextBox();
            this.lblUserIdBuffer = new System.Windows.Forms.Label();
            this.txtUserIdBuffer = new System.Windows.Forms.TextBox();
            this.btnRegTempIntoBuffer = new System.Windows.Forms.Button();
            this.btnRemoveIdFromBuffer = new System.Windows.Forms.Button();
            this.listBox1 = new System.Windows.Forms.ListBox();
            this.btnEncrypt = new System.Windows.Forms.Button();
            this.btnDecrypt = new System.Windows.Forms.Button();
            this.txtStrDec = new System.Windows.Forms.TextBox();
            this.SuspendLayout();
            // 
            // txtStrEnc
            // 
            this.txtStrEnc.Location = new System.Drawing.Point(48, 131);
            this.txtStrEnc.Name = "txtStrEnc";
            this.txtStrEnc.Size = new System.Drawing.Size(481, 20);
            this.txtStrEnc.TabIndex = 45;
            // 
            // Label5
            // 
            this.Label5.Location = new System.Drawing.Point(8, 187);
            this.Label5.Name = "Label5";
            this.Label5.Size = new System.Drawing.Size(40, 16);
            this.Label5.TabIndex = 43;
            this.Label5.Text = "String :";
            // 
            // Label4
            // 
            this.Label4.Location = new System.Drawing.Point(8, 131);
            this.Label4.Name = "Label4";
            this.Label4.Size = new System.Drawing.Size(40, 16);
            this.Label4.TabIndex = 42;
            this.Label4.Text = "String :";
            // 
            // Label3
            // 
            this.Label3.Location = new System.Drawing.Point(8, 107);
            this.Label3.Name = "Label3";
            this.Label3.Size = new System.Drawing.Size(32, 16);
            this.Label3.TabIndex = 41;
            this.Label3.Text = "Key :";
            // 
            // btnInit
            // 
            this.btnInit.Location = new System.Drawing.Point(395, 45);
            this.btnInit.Name = "btnInit";
            this.btnInit.Size = new System.Drawing.Size(134, 23);
            this.btnInit.TabIndex = 40;
            this.btnInit.Text = "Init OFIS Sensor";
            this.btnInit.Click += new System.EventHandler(this.btnInit_Click);
            // 
            // btnSaveBmp
            // 
            this.btnSaveBmp.Location = new System.Drawing.Point(134, 75);
            this.btnSaveBmp.Name = "btnSaveBmp";
            this.btnSaveBmp.Size = new System.Drawing.Size(128, 23);
            this.btnSaveBmp.TabIndex = 38;
            this.btnSaveBmp.Text = "Save Tpl As Bmp";
            this.btnSaveBmp.Click += new System.EventHandler(this.btnSaveBmp_Click);
            // 
            // btnSaveJpg
            // 
            this.btnSaveJpg.Location = new System.Drawing.Point(8, 75);
            this.btnSaveJpg.Name = "btnSaveJpg";
            this.btnSaveJpg.Size = new System.Drawing.Size(120, 23);
            this.btnSaveJpg.TabIndex = 37;
            this.btnSaveJpg.Text = "Save Tpl As Jpg";
            this.btnSaveJpg.Click += new System.EventHandler(this.btnSaveJpg_Click);
            // 
            // btnVerify
            // 
            this.btnVerify.Location = new System.Drawing.Point(88, 43);
            this.btnVerify.Name = "btnVerify";
            this.btnVerify.Size = new System.Drawing.Size(84, 23);
            this.btnVerify.TabIndex = 33;
            this.btnVerify.Text = "Verify";
            this.btnVerify.Click += new System.EventHandler(this.btnVerify_Click);
            // 
            // btnRegister
            // 
            this.btnRegister.Location = new System.Drawing.Point(8, 43);
            this.btnRegister.Name = "btnRegister";
            this.btnRegister.Size = new System.Drawing.Size(75, 23);
            this.btnRegister.TabIndex = 32;
            this.btnRegister.Text = "Register";
            this.btnRegister.Click += new System.EventHandler(this.btnRegister_Click);
            // 
            // btnOK
            // 
            this.btnOK.Enabled = false;
            this.btnOK.Location = new System.Drawing.Point(178, 7);
            this.btnOK.Name = "btnOK";
            this.btnOK.Size = new System.Drawing.Size(75, 23);
            this.btnOK.TabIndex = 30;
            this.btnOK.Text = "OK";
            this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
            // 
            // Label2
            // 
            this.Label2.Location = new System.Drawing.Point(305, 11);
            this.Label2.Name = "Label2";
            this.Label2.Size = new System.Drawing.Size(80, 16);
            this.Label2.TabIndex = 28;
            this.Label2.Text = "Finger Index :";
            // 
            // edtUserName
            // 
            this.edtUserName.Location = new System.Drawing.Point(72, 8);
            this.edtUserName.Name = "edtUserName";
            this.edtUserName.Size = new System.Drawing.Size(100, 20);
            this.edtUserName.TabIndex = 27;
            // 
            // Label1
            // 
            this.Label1.Location = new System.Drawing.Point(8, 11);
            this.Label1.Name = "Label1";
            this.Label1.Size = new System.Drawing.Size(64, 16);
            this.Label1.TabIndex = 26;
            this.Label1.Text = "UserName :";
            // 
            // label6
            // 
            this.label6.Location = new System.Drawing.Point(8, 217);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(120, 16);
            this.label6.TabIndex = 51;
            this.label6.Text = "1 To 1 Threshold :";
            // 
            // edt1to1
            // 
            this.edt1to1.Location = new System.Drawing.Point(106, 214);
            this.edt1to1.Name = "edt1to1";
            this.edt1to1.Size = new System.Drawing.Size(32, 20);
            this.edt1to1.TabIndex = 53;
            this.edt1to1.Text = "10";
            // 
            // btnGet1to1
            // 
            this.btnGet1to1.Location = new System.Drawing.Point(270, 212);
            this.btnGet1to1.Name = "btnGet1to1";
            this.btnGet1to1.Size = new System.Drawing.Size(121, 23);
            this.btnGet1to1.TabIndex = 55;
            this.btnGet1to1.Text = "Get 1 To 1 Threshold";
            this.btnGet1to1.Click += new System.EventHandler(this.btnGet1to1_Click);
            // 
            // btnSet1to1
            // 
            this.btnSet1to1.Location = new System.Drawing.Point(395, 212);
            this.btnSet1to1.Name = "btnSet1to1";
            this.btnSet1to1.Size = new System.Drawing.Size(134, 23);
            this.btnSet1to1.TabIndex = 56;
            this.btnSet1to1.Text = "Set 1 To 1 Threshold";
            this.btnSet1to1.Click += new System.EventHandler(this.btnSet1to1_Click);
            // 
            // lblFingerIndexResult
            // 
            this.lblFingerIndexResult.AutoSize = true;
            this.lblFingerIndexResult.ForeColor = System.Drawing.Color.Blue;
            this.lblFingerIndexResult.Location = new System.Drawing.Point(372, 12);
            this.lblFingerIndexResult.Name = "lblFingerIndexResult";
            this.lblFingerIndexResult.Size = new System.Drawing.Size(13, 13);
            this.lblFingerIndexResult.TabIndex = 57;
            this.lblFingerIndexResult.Text = "0";
            // 
            // lblFPVer
            // 
            this.lblFPVer.AutoSize = true;
            this.lblFPVer.Location = new System.Drawing.Point(391, 11);
            this.lblFPVer.Name = "lblFPVer";
            this.lblFPVer.Size = new System.Drawing.Size(58, 13);
            this.lblFPVer.TabIndex = 58;
            this.lblFPVer.Text = "FPVersion:";
            // 
            // rdbnine
            // 
            this.rdbnine.AutoSize = true;
            this.rdbnine.Checked = true;
            this.rdbnine.Location = new System.Drawing.Point(455, 10);
            this.rdbnine.Name = "rdbnine";
            this.rdbnine.Size = new System.Drawing.Size(31, 17);
            this.rdbnine.TabIndex = 59;
            this.rdbnine.TabStop = true;
            this.rdbnine.Text = "9";
            this.rdbnine.UseVisualStyleBackColor = true;
            this.rdbnine.CheckedChanged += new System.EventHandler(this.rdbnine_CheckedChanged);
            // 
            // rbdten
            // 
            this.rbdten.AutoSize = true;
            this.rbdten.Location = new System.Drawing.Point(492, 11);
            this.rbdten.Name = "rbdten";
            this.rbdten.Size = new System.Drawing.Size(37, 17);
            this.rbdten.TabIndex = 60;
            this.rbdten.TabStop = true;
            this.rbdten.Text = "10";
            this.rbdten.UseVisualStyleBackColor = true;
            this.rbdten.CheckedChanged += new System.EventHandler(this.rbdten_CheckedChanged);
            // 
            // btnSetLanguage
            // 
            this.btnSetLanguage.Location = new System.Drawing.Point(178, 43);
            this.btnSetLanguage.Name = "btnSetLanguage";
            this.btnSetLanguage.Size = new System.Drawing.Size(84, 23);
            this.btnSetLanguage.TabIndex = 61;
            this.btnSetLanguage.Text = "Set Language";
            this.btnSetLanguage.UseVisualStyleBackColor = true;
            this.btnSetLanguage.Click += new System.EventHandler(this.btnSetLanguage_Click);
            // 
            // cboSetLanguage
            // 
            this.cboSetLanguage.ForeColor = System.Drawing.Color.Blue;
            this.cboSetLanguage.FormattingEnabled = true;
            this.cboSetLanguage.Location = new System.Drawing.Point(268, 45);
            this.cboSetLanguage.Name = "cboSetLanguage";
            this.cboSetLanguage.Size = new System.Drawing.Size(121, 21);
            this.cboSetLanguage.TabIndex = 62;
            this.cboSetLanguage.Text = "ENGLISH";
            this.cboSetLanguage.SelectedIndexChanged += new System.EventHandler(this.cboSetLanguage_SelectedIndexChanged);
            // 
            // btnRegTplFromFile
            // 
            this.btnRegTplFromFile.Location = new System.Drawing.Point(268, 75);
            this.btnRegTplFromFile.Name = "btnRegTplFromFile";
            this.btnRegTplFromFile.Size = new System.Drawing.Size(123, 23);
            this.btnRegTplFromFile.TabIndex = 63;
            this.btnRegTplFromFile.Text = "RegTemplateFromFile";
            this.btnRegTplFromFile.UseVisualStyleBackColor = true;
            this.btnRegTplFromFile.Click += new System.EventHandler(this.btnRegTplFromFile_Click);
            // 
            // btnVerTplFromFile
            // 
            this.btnVerTplFromFile.Location = new System.Drawing.Point(395, 75);
            this.btnVerTplFromFile.Name = "btnVerTplFromFile";
            this.btnVerTplFromFile.Size = new System.Drawing.Size(134, 23);
            this.btnVerTplFromFile.TabIndex = 64;
            this.btnVerTplFromFile.Text = "VerTemplateFromFile";
            this.btnVerTplFromFile.UseVisualStyleBackColor = true;
            this.btnVerTplFromFile.Click += new System.EventHandler(this.btnVerTplFromFile_Click);
            // 
            // txtKey
            // 
            this.txtKey.Location = new System.Drawing.Point(48, 105);
            this.txtKey.Name = "txtKey";
            this.txtKey.Size = new System.Drawing.Size(124, 20);
            this.txtKey.TabIndex = 65;
            // 
            // lblDPI
            // 
            this.lblDPI.AutoSize = true;
            this.lblDPI.Location = new System.Drawing.Point(267, 107);
            this.lblDPI.Name = "lblDPI";
            this.lblDPI.Size = new System.Drawing.Size(28, 13);
            this.lblDPI.TabIndex = 66;
            this.lblDPI.Text = "DPI:";
            // 
            // txtDPI
            // 
            this.txtDPI.Location = new System.Drawing.Point(297, 103);
            this.txtDPI.Name = "txtDPI";
            this.txtDPI.Size = new System.Drawing.Size(92, 20);
            this.txtDPI.TabIndex = 67;
            this.txtDPI.Text = "600";
            // 
            // lblDPI1
            // 
            this.lblDPI1.AutoSize = true;
            this.lblDPI1.Location = new System.Drawing.Point(395, 107);
            this.lblDPI1.Name = "lblDPI1";
            this.lblDPI1.Size = new System.Drawing.Size(28, 13);
            this.lblDPI1.TabIndex = 68;
            this.lblDPI1.Text = "DPI:";
            // 
            // txtDPI1
            // 
            this.txtDPI1.Location = new System.Drawing.Point(424, 103);
            this.txtDPI1.Name = "txtDPI1";
            this.txtDPI1.Size = new System.Drawing.Size(105, 20);
            this.txtDPI1.TabIndex = 69;
            this.txtDPI1.Text = "500";
            // 
            // btnPlayBeep
            // 
            this.btnPlayBeep.Location = new System.Drawing.Point(8, 238);
            this.btnPlayBeep.Name = "btnPlayBeep";
            this.btnPlayBeep.Size = new System.Drawing.Size(83, 23);
            this.btnPlayBeep.TabIndex = 70;
            this.btnPlayBeep.Text = "Play Beep";
            this.btnPlayBeep.UseVisualStyleBackColor = true;
            this.btnPlayBeep.Click += new System.EventHandler(this.btnPlayBeep_Click);
            // 
            // btnPlayGreen
            // 
            this.btnPlayGreen.Location = new System.Drawing.Point(97, 238);
            this.btnPlayGreen.Name = "btnPlayGreen";
            this.btnPlayGreen.Size = new System.Drawing.Size(84, 23);
            this.btnPlayGreen.TabIndex = 71;
            this.btnPlayGreen.Text = "Play Green";
            this.btnPlayGreen.UseVisualStyleBackColor = true;
            this.btnPlayGreen.Click += new System.EventHandler(this.btnPlayGreen_Click);
            // 
            // btnPlayRed
            // 
            this.btnPlayRed.Location = new System.Drawing.Point(187, 238);
            this.btnPlayRed.Name = "btnPlayRed";
            this.btnPlayRed.Size = new System.Drawing.Size(85, 23);
            this.btnPlayRed.TabIndex = 72;
            this.btnPlayRed.Text = "Play Red";
            this.btnPlayRed.UseVisualStyleBackColor = true;
            this.btnPlayRed.Click += new System.EventHandler(this.btnPlayRed_Click);
            // 
            // shapeContainer1
            // 
            this.shapeContainer1.Location = new System.Drawing.Point(0, 0);
            this.shapeContainer1.Margin = new System.Windows.Forms.Padding(0);
            this.shapeContainer1.Name = "shapeContainer1";
            this.shapeContainer1.Shapes.AddRange(new Microsoft.VisualBasic.PowerPacks.Shape[] {
            this.lineShape1});
            this.shapeContainer1.Size = new System.Drawing.Size(537, 494);
            this.shapeContainer1.TabIndex = 73;
            this.shapeContainer1.TabStop = false;
            // 
            // lineShape1
            // 
            this.lineShape1.BorderColor = System.Drawing.SystemColors.ScrollBar;
            this.lineShape1.Name = "lineShape1";
            this.lineShape1.X1 = 11;
            this.lineShape1.X2 = 526;
            this.lineShape1.Y1 = 266;
            this.lineShape1.Y2 = 266;
            // 
            // btnAddTempIntoBuffer
            // 
            this.btnAddTempIntoBuffer.Location = new System.Drawing.Point(8, 273);
            this.btnAddTempIntoBuffer.Name = "btnAddTempIntoBuffer";
            this.btnAddTempIntoBuffer.Size = new System.Drawing.Size(173, 23);
            this.btnAddTempIntoBuffer.TabIndex = 74;
            this.btnAddTempIntoBuffer.Text = "Add all templates into buffer";
            this.btnAddTempIntoBuffer.UseVisualStyleBackColor = true;
            this.btnAddTempIntoBuffer.Click += new System.EventHandler(this.btnAddTempIntoBuffer_Click);
            // 
            // btnIdentifyFromBuffer
            // 
            this.btnIdentifyFromBuffer.Location = new System.Drawing.Point(187, 273);
            this.btnIdentifyFromBuffer.Name = "btnIdentifyFromBuffer";
            this.btnIdentifyFromBuffer.Size = new System.Drawing.Size(168, 23);
            this.btnIdentifyFromBuffer.TabIndex = 75;
            this.btnIdentifyFromBuffer.Text = "Identification from buffer";
            this.btnIdentifyFromBuffer.UseVisualStyleBackColor = true;
            this.btnIdentifyFromBuffer.Click += new System.EventHandler(this.btnIdentifyFromBuffer_Click);
            // 
            // lblUsernameBuffer
            // 
            this.lblUsernameBuffer.AutoSize = true;
            this.lblUsernameBuffer.Location = new System.Drawing.Point(8, 304);
            this.lblUsernameBuffer.Name = "lblUsernameBuffer";
            this.lblUsernameBuffer.Size = new System.Drawing.Size(64, 13);
            this.lblUsernameBuffer.TabIndex = 76;
            this.lblUsernameBuffer.Text = "User ID      :";
            // 
            // txtUsernameBuffer
            // 
            this.txtUsernameBuffer.Location = new System.Drawing.Point(72, 301);
            this.txtUsernameBuffer.Name = "txtUsernameBuffer";
            this.txtUsernameBuffer.Size = new System.Drawing.Size(109, 20);
            this.txtUsernameBuffer.TabIndex = 77;
            // 
            // lblUserIdBuffer
            // 
            this.lblUserIdBuffer.AutoSize = true;
            this.lblUserIdBuffer.Location = new System.Drawing.Point(8, 330);
            this.lblUserIdBuffer.Name = "lblUserIdBuffer";
            this.lblUserIdBuffer.Size = new System.Drawing.Size(67, 13);
            this.lblUserIdBuffer.TabIndex = 78;
            this.lblUserIdBuffer.Text = "User ID       :";
            // 
            // txtUserIdBuffer
            // 
            this.txtUserIdBuffer.Location = new System.Drawing.Point(72, 327);
            this.txtUserIdBuffer.Name = "txtUserIdBuffer";
            this.txtUserIdBuffer.Size = new System.Drawing.Size(109, 20);
            this.txtUserIdBuffer.TabIndex = 79;
            // 
            // btnRegTempIntoBuffer
            // 
            this.btnRegTempIntoBuffer.Location = new System.Drawing.Point(187, 299);
            this.btnRegTempIntoBuffer.Name = "btnRegTempIntoBuffer";
            this.btnRegTempIntoBuffer.Size = new System.Drawing.Size(168, 23);
            this.btnRegTempIntoBuffer.TabIndex = 80;
            this.btnRegTempIntoBuffer.Text = "Register Templates into Buffer";
            this.btnRegTempIntoBuffer.UseVisualStyleBackColor = true;
            this.btnRegTempIntoBuffer.Click += new System.EventHandler(this.btnRegTempIntoBuffer_Click);
            // 
            // btnRemoveIdFromBuffer
            // 
            this.btnRemoveIdFromBuffer.Location = new System.Drawing.Point(187, 325);
            this.btnRemoveIdFromBuffer.Name = "btnRemoveIdFromBuffer";
            this.btnRemoveIdFromBuffer.Size = new System.Drawing.Size(168, 23);
            this.btnRemoveIdFromBuffer.TabIndex = 81;
            this.btnRemoveIdFromBuffer.Text = "Remove ID from Buffer";
            this.btnRemoveIdFromBuffer.UseVisualStyleBackColor = true;
            this.btnRemoveIdFromBuffer.Click += new System.EventHandler(this.btnRemoveIdFromBuffer_Click);
            // 
            // listBox1
            // 
            this.listBox1.FormattingEnabled = true;
            this.listBox1.Location = new System.Drawing.Point(11, 353);
            this.listBox1.Name = "listBox1";
            this.listBox1.Size = new System.Drawing.Size(516, 134);
            this.listBox1.TabIndex = 82;
            // 
            // btnEncrypt
            // 
            this.btnEncrypt.Location = new System.Drawing.Point(48, 155);
            this.btnEncrypt.Name = "btnEncrypt";
            this.btnEncrypt.Size = new System.Drawing.Size(75, 23);
            this.btnEncrypt.TabIndex = 83;
            this.btnEncrypt.Text = "Encrypt ↓";
            this.btnEncrypt.UseVisualStyleBackColor = true;
            this.btnEncrypt.Click += new System.EventHandler(this.btnEncrypt_Click_1);
            // 
            // btnDecrypt
            // 
            this.btnDecrypt.Location = new System.Drawing.Point(134, 155);
            this.btnDecrypt.Name = "btnDecrypt";
            this.btnDecrypt.Size = new System.Drawing.Size(75, 23);
            this.btnDecrypt.TabIndex = 84;
            this.btnDecrypt.Text = "Decrypt ↑";
            this.btnDecrypt.UseVisualStyleBackColor = true;
            this.btnDecrypt.Click += new System.EventHandler(this.btnDecrypt_Click_1);
            // 
            // txtStrDec
            // 
            this.txtStrDec.Location = new System.Drawing.Point(48, 183);
            this.txtStrDec.Name = "txtStrDec";
            this.txtStrDec.Size = new System.Drawing.Size(479, 20);
            this.txtStrDec.TabIndex = 85;
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(537, 494);
            this.Controls.Add(this.txtStrDec);
            this.Controls.Add(this.btnDecrypt);
            this.Controls.Add(this.btnEncrypt);
            this.Controls.Add(this.listBox1);
            this.Controls.Add(this.btnRemoveIdFromBuffer);
            this.Controls.Add(this.btnRegTempIntoBuffer);
            this.Controls.Add(this.txtUserIdBuffer);
            this.Controls.Add(this.lblUserIdBuffer);
            this.Controls.Add(this.txtUsernameBuffer);
            this.Controls.Add(this.lblUsernameBuffer);
            this.Controls.Add(this.btnIdentifyFromBuffer);
            this.Controls.Add(this.btnAddTempIntoBuffer);
            this.Controls.Add(this.btnPlayRed);
            this.Controls.Add(this.btnPlayGreen);
            this.Controls.Add(this.btnPlayBeep);
            this.Controls.Add(this.txtDPI1);
            this.Controls.Add(this.lblDPI1);
            this.Controls.Add(this.txtDPI);
            this.Controls.Add(this.lblDPI);
            this.Controls.Add(this.txtKey);
            this.Controls.Add(this.btnVerTplFromFile);
            this.Controls.Add(this.btnRegTplFromFile);
            this.Controls.Add(this.cboSetLanguage);
            this.Controls.Add(this.btnSetLanguage);
            this.Controls.Add(this.rbdten);
            this.Controls.Add(this.rdbnine);
            this.Controls.Add(this.lblFPVer);
            this.Controls.Add(this.lblFingerIndexResult);
            this.Controls.Add(this.btnSet1to1);
            this.Controls.Add(this.btnGet1to1);
            this.Controls.Add(this.edt1to1);
            this.Controls.Add(this.label6);
            this.Controls.Add(this.txtStrEnc);
            this.Controls.Add(this.Label5);
            this.Controls.Add(this.Label4);
            this.Controls.Add(this.Label3);
            this.Controls.Add(this.btnInit);
            this.Controls.Add(this.btnSaveBmp);
            this.Controls.Add(this.btnSaveJpg);
            this.Controls.Add(this.btnVerify);
            this.Controls.Add(this.btnRegister);
            this.Controls.Add(this.btnOK);
            this.Controls.Add(this.Label2);
            this.Controls.Add(this.edtUserName);
            this.Controls.Add(this.Label1);
            this.Controls.Add(this.shapeContainer1);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "FingerTec OFIS 3.0 C# Demo";
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void btnInit_Click(object sender, System.EventArgs e)
		{
            MessageBox.Show("Init Result : " + axOfisMain2.InitSensor()); //result =0 success, 1 = Not install driver, 2 = Not connect sensor
		}

		private void btnEnglish_Click(object sender, System.EventArgs e)
		{
            if (axOfisMain2.SetLanguageFile("Ofis.en") == true) //set english
				MessageBox.Show("OK");
			else
				MessageBox.Show("Failed");
		}

		private void btnCHS_Click(object sender, System.EventArgs e)
		{
            if (axOfisMain2.SetLanguageFile("Ofis.chs") == true) //set chinese simplified
				MessageBox.Show("OK");
			else
				MessageBox.Show("Failed");
		}

		private void btnCHT_Click(object sender, System.EventArgs e)
		{
            if (axOfisMain2.SetLanguageFile("Ofis.cht") == true) //set chinese traditional
				MessageBox.Show("OK");
			else
				MessageBox.Show("Failed");
		}

		private void btnSaveJpg_Click(object sender, System.EventArgs e)
		{
			SaveFileDialog1.DefaultExt = "jpg";
			SaveFileDialog1.Filter = "Jpeg files (*.jpg)|*.jpg|All files (*.*)|*.*";
			SaveFileDialog1.ShowDialog();
            axOfisMain2.SaveFingerTemplateAsJPG(SaveFileDialog1.FileName);//'save the last captured finger template into jpg format  (use register or verify to capture finger first)
		}

		private void btnSaveBmp_Click(object sender, System.EventArgs e)
		{
			SaveFileDialog1.DefaultExt = "bmp";
			SaveFileDialog1.Filter = "BMP  files (*.bmp)|*.bmp|All files (*.*)|*.*";
			SaveFileDialog1.ShowDialog();
            axOfisMain2.SaveFingerTemplateAsBMP(SaveFileDialog1.FileName); //save the last captured finger template into bmp format  (use register or verify to capture finger first)
		}

		private void btnRegister_Click(object sender, System.EventArgs e)
		{
            axOfisMain2.IsAutoRegister = true;
            axOfisMain2.CheckFinger = "0000000000";// left thumb index =1 , right thumb index = 6; set 1=check, 0=uncheck  ; example check left thumb = 1000000000, check right thumb = 0000010000
			//OfisMain.FingerIndex();
            if (axOfisMain2.Register() == true)
			{
                int i = axOfisMain2.FingerIndex;//register finger index
                lblFingerIndexResult.Text = Convert.ToString( i);					
					
				MessageBox.Show("Please enter your username");
				edtUserName.Focus();
				btnOK.Enabled = true;

                listBox1.Items.Add("CheckFinger: " + axOfisMain2.CheckFinger);
			}
			
		}

		private void btnOK_Click(object sender, System.EventArgs e)
		{
			OleDbConnection cn;
			OleDbCommand cmd;
			int iCount, i;		
			string sRegTpl;
			i = 1;

                while (i <= 10)
                {
                    sRegTpl = axOfisMain2.GetRegFingerTemplate(i);

                    if (sRegTpl != null)
                    {
                        //connect OfisDemo.mdb
                        cn = new OleDbConnection("Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Jet OLEDB:Database Password=;Data Source='OfisDemo.mdb';Password=;Jet OLEDB:Engine Type=5;Jet OLEDB:Global Bulk Transactions=1;Provider='Microsoft.Jet.OLEDB.4.0';Jet OLEDB:System database=;Jet OLEDB:SFP=False;Extended Properties=;Mode=Share Deny None;Jet OLEDB:New Database Password=;Jet OLEDB:Create System Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;User ID=Admin;Jet OLEDB:Encrypt Database=False");
                        cn.Open();
                        string str = "insert into Users (username, policy, fingertemplate) values (@edtUserName, @policy, @RegisterTemplate)";
                        cmd = new OleDbCommand(str, cn);

                        cmd.Parameters.AddWithValue("@edtUserName", edtUserName.Text);
                        cmd.Parameters.AddWithValue("@policy", g_sFPVer);
                        cmd.Parameters.AddWithValue("@RegisterTemplate", sRegTpl);
                       
                        iCount = cmd.ExecuteNonQuery();
                        cn.Close();
                    }
                    i++;
                }

                MessageBox.Show("Inserted  record");  // insert new register user and finger template
                listBox1.Items.Add("Registered User : " + edtUserName.Text);
            
		}

		private void btnVerify_Click(object sender, System.EventArgs e)
		{
			string sFgr;

            if (axOfisMain2.GetVerTemplate())   //activate verify UI
			{
                sFgr = axOfisMain2.VerifyTemplate;  
				g_sFgr2 = sFgr ;
				Verify(sFgr);
			}            
           
		}

		private void btnLoadImage_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog1.ShowDialog();
            if (axOfisMain2.AddImageFile(OpenFileDialog1.FileName, 500))  //'load finger image file, convert into string format
			{
                g_sFgr1 = axOfisMain2.GetTemplateString();		//get converted finger string
                axOfisMain2.InitSensor();											//initialize sensor before matching
				  Verify(g_sFgr1);													//matching finger
			}
			else
				MessageBox.Show("Failed");
       
		}

		private void Verify(string sFgr)
		{
			string sTplFgr="", sUser="", sResult;
			bool bMatched ; 
			OleDbConnection cn;
			OleDbCommand cmd;
			OleDbDataReader dr;
			sResult = "";
			bMatched = false;

            //listBox1.Items.Add("--------------------------------------------------------------------------------");
			listBox1.Items.Add("Matching Start  " +DateTime.Now.ToString("f"));

        
			cn = new OleDbConnection("Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Jet OLEDB:Database Password=;Data Source='OfisDemo.mdb';Password=;Jet OLEDB:Engine Type=5;Jet OLEDB:Global Bulk Transactions=1;Provider='Microsoft.Jet.OLEDB.4.0';Jet OLEDB:System database=;Jet OLEDB:SFP=False;Extended Properties=;Mode=Share Deny None;Jet OLEDB:New Database Password=;Jet OLEDB:Create System Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;User ID=Admin;Jet OLEDB:Encrypt Database=False");
			cn.Open();
			cmd = new OleDbCommand("select * from users order by id", cn) ; //query all users
			dr = cmd.ExecuteReader();

			while ((dr.Read()) && (bMatched ==false)) 
			{
                //sUser += dr[1];
                //sTplFgr += dr[4];
                sUser = dr["id"].ToString();
                sTplFgr = dr["fingertemplate"].ToString();


                if (axOfisMain2.MatchFinger(sTplFgr, sFgr) == true) // matching finger template
				{
					bMatched = true;
					sResult = sUser;
				}
				else
				{
					sUser="";
					sTplFgr="";
				}
	    	}
        dr.Close();
        cn.Close();


        if ( sResult == "" )
            sResult = "False";

        listBox1.Items.Add("Verified :" + sResult);
        listBox1.Items.Add("Matching End  " + DateTime.Now.ToString("f"));
        listBox1.Items.Add("--------------------------------------------------------------------------------");

	}

        //private void btnEncrypt_Click(object sender, System.EventArgs e)
        //{
        //    txtStrDec.Text = axOfisMain2.Encrypt(txtStrEnc.Text, txtKey.Text); // encryption
        //}

        //private void btnDecrypt_Click(object sender, System.EventArgs e)
        //{
        //    txtStrEnc.Text = axOfisMain2.Decrypt(txtStrDec.Text, txtKey.Text); // decryption
        //}

		private void btnGet1to1_Click(object sender, System.EventArgs e)
		{
            edt1to1.Text = Convert.ToString(axOfisMain2.OneToOneThreshold);
				  listBox1.Items.Add("OneToOneThreshold :" + edt1to1.Text);
		}

		private void btnSet1to1_Click(object sender, System.EventArgs e)
		{
            axOfisMain2.OneToOneThreshold = Convert.ToInt32(edt1to1.Text);
            listBox1.Items.Add("Set OneToOneThreshold :" + edt1to1.Text + "  OK");
		}

        private void cboSetLanguage_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void rdbnine_CheckedChanged(object sender, EventArgs e)
        {
            if (rdbnine.Checked)
            {
                g_sFPVer = "9";
                axOfisMain2.SetFPEngineVersion(9);
            }
        }

        private void rbdten_CheckedChanged(object sender, EventArgs e)
        {
            if (rbdten.Checked)
            {
                g_sFPVer = "10";
                axOfisMain2.SetFPEngineVersion(10);            
            }
        }

        private void btnSetLanguage_Click(object sender, EventArgs e)
        {
            switch(cboSetLanguage.Text)
            {
                case "ENGLISH" :
                                if (axOfisMain2.SetLanguageFile("Ofis.en")) 
                                    MessageBox.Show("OK");
                                else
                                    MessageBox.Show("Failed");
                                break;
                case "CHINESE SIMPLIFIED" : 
                                if (axOfisMain2.SetLanguageFile("Ofis.chs")) 
                                    MessageBox.Show("OK");
                                else
                                    MessageBox.Show("Failed");
                                break;
                case "CHINESE TRADITIONAL" :
                                if (axOfisMain2.SetLanguageFile("Ofis.cht")) 
                                    MessageBox.Show("OK");
                                else
                                    MessageBox.Show("Failed");
                                break;
                case "MALAY" :
                                if (axOfisMain2.SetLanguageFile("Ofis.my")) 
                                    MessageBox.Show("OK");
                                else
                                    MessageBox.Show("Failed");
                                break;
                case "SPANISH" :
                                if (axOfisMain2.SetLanguageFile("Ofis.sp")) 
                                    MessageBox.Show("OK");
                                else
                                    MessageBox.Show("Failed");
                                break;
                case "ARABIC" : 
                                if (axOfisMain2.SetLanguageFile("Ofis.ar")) 
                                    MessageBox.Show("OK");
                                else
                                    MessageBox.Show("Failed");
                                break;
            }
        }

        private void btnRegTplFromFile_Click(object sender, EventArgs e)
        {
            if (rdbnine.Checked) 
                axOfisMain2.SetFPEngineVersion(9);
            else
                axOfisMain2.SetFPEngineVersion(10);

            string sFgr;
            if (String.IsNullOrEmpty(edtUserName.Text)) 
                MessageBox.Show("Please enter your username");
            else
            {
                OpenFileDialog1.ShowDialog();
                sFgr = axOfisMain2.GetRegTemplateFromFile(OpenFileDialog1.FileName, Convert.ToInt32(txtDPI.Text));
                if (String.IsNullOrEmpty(sFgr) == false) 
                    Register(sFgr);
            }
        }

        private void Register(string sFgr)
        {
            OleDbConnection cn;
            OleDbCommand cmd;
            int iCount;
           
            //connect OfisDemo.mdb
            cn = new OleDbConnection("Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Jet OLEDB:Database Password=;Data Source='OfisDemo.mdb';Password=;Jet OLEDB:Engine Type=5;Jet OLEDB:Global Bulk Transactions=1;Provider='Microsoft.Jet.OLEDB.4.0';Jet OLEDB:System database=;Jet OLEDB:SFP=False;Extended Properties=;Mode=Share Deny None;Jet OLEDB:New Database Password=;Jet OLEDB:Create System Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;User ID=Admin;Jet OLEDB:Encrypt Database=False");
            cn.Open();
            string str = "insert into Users (username, policy, fingertemplate) values (@edtUserName, @policy, @RegisterTemplate)";
            cmd = new OleDbCommand(str, cn);

            cmd.Parameters.AddWithValue("@edtUserName", edtUserName.Text);
            cmd.Parameters.AddWithValue("@policy", g_sFPVer);
            cmd.Parameters.AddWithValue("@RegisterTemplate", sFgr);

            iCount = cmd.ExecuteNonQuery();
            cn.Close();

            MessageBox.Show("Inserted  record");  // insert new register user and finger template
            listBox1.Items.Add("Registered User : " + edtUserName.Text);
        }

        private void btnVerTplFromFile_Click(object sender, EventArgs e)
        {
            if (rdbnine.Checked) 
                axOfisMain2.SetFPEngineVersion(9);
            else
                axOfisMain2.SetFPEngineVersion(10);

            OpenFileDialog1.ShowDialog();
            string sFgr;

            sFgr = axOfisMain2.GetVerTemplateFromFile(OpenFileDialog1.FileName, Convert.ToInt32(txtDPI1.Text));
            if (String.IsNullOrEmpty(sFgr)) 
                Verify(sFgr);
        }

        private void btnEncrypt_Click_1(object sender, EventArgs e)
        {
            txtStrDec.Text = axOfisMain2.Encrypt(txtStrEnc.Text, txtKey.Text); // encryption
        }

        private void btnDecrypt_Click_1(object sender, EventArgs e)
        {
            txtStrEnc.Text = axOfisMain2.Decrypt(txtStrDec.Text, txtKey.Text); // decryption
        }

        private void btnPlayBeep_Click(object sender, EventArgs e)
        {
            axOfisMain2.InitSensor();
            axOfisMain2.PlayBeep(true);
            axOfisMain2.PlayBeep(false);
        }

        private void btnPlayGreen_Click(object sender, EventArgs e)
        {
            axOfisMain2.InitSensor();
            axOfisMain2.PlayGreenLight(true);
            axOfisMain2.PlayGreenLight(false);
        }

        private void btnPlayRed_Click(object sender, EventArgs e)
        {
            axOfisMain2.InitSensor();
            axOfisMain2.PlayRedLight(true);
            axOfisMain2.PlayRedLight(false);
        }

        private void btnAddTempIntoBuffer_Click(object sender, EventArgs e)
        {
            string sTplFgr = "";
            int sUser, counter, result;
            OleDbConnection cn;
            OleDbCommand cmd;
            OleDbDataReader dr;
            axOfisMain2.InitSensor();

            FHandle = axOfisMain2.CreateBuffer();

            counter = 0;

            try 
            {// connect to OfisDemo.mdb
                cn = new OleDbConnection("Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Jet OLEDB:Database Password=;Data Source='OfisDemo.mdb';Password=;Jet OLEDB:Engine Type=5;Jet OLEDB:Global Bulk Transactions=1;Provider='Microsoft.Jet.OLEDB.4.0';Jet OLEDB:System database=;Jet OLEDB:SFP=False;Extended Properties=;Mode=Share Deny None;Jet OLEDB:New Database Password=;Jet OLEDB:Create System Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;User ID=Admin;Jet OLEDB:Encrypt Database=False");
                cn.Open();
                cmd = new OleDbCommand("SELECT * FROM USERS WHERE POLICY = '" + g_sFPVer + "'", cn); // query all users
                dr = cmd.ExecuteReader();

                while (dr.Read())
                {
                    sUser = Convert.ToInt32(dr["id"].ToString());
                    sTplFgr = dr["fingertemplate"].ToString();

                    result = axOfisMain2.AddRegTemplateToBuffer(FHandle, sUser, sTplFgr);
                    if (result == 0) 
                        listBox1.Items.Add("Add User " + Convert.ToString(sUser) + " failed");
                    else
                        counter = counter + 1;
                }
                dr.Close();
                cn.Close();
            }
            catch
            {
            }
            listBox1.Items.Clear(); //everytime click the add all fingerprint to buffer button, the list will empty first
            listBox1.Items.Add("Added Fingerprint to Buffer: " + counter.ToString());

        }

        private void btnIdentifyFromBuffer_Click(object sender, EventArgs e)
        {
            Int32 userid;
            string sTplFgr;
            //Dim FHandle As Integer
            //FHandle = OfisMain.CreateBuffer()

            axOfisMain2.GetVerTemplate();
            sTplFgr = axOfisMain2.VerifyTemplate;
        
            userid = axOfisMain2.IdentificationTemplateFromBuffer(FHandle, sTplFgr);

            listBox1.Items.Add("--------------------------------------------------------------------------------");
            listBox1.Items.Add("Matching Start  " + DateTime.Now.ToString("f"));
            if (userid != -1) 
                listBox1.Items.Add("Verified Fingerprint: " + userid.ToString()); // + ", Name: " + username)
            else
                listBox1.Items.Add("Verified failed!");

            listBox1.Items.Add("Matching End  " + DateTime.Now.ToString("f"));
            listBox1.Items.Add("--------------------------------------------------------------------------------");
            txtUsernameBuffer.Text = "";
            txtUserIdBuffer.Text = "";
        }

        private void btnRegTempIntoBuffer_Click(object sender, EventArgs e)
        {
            string sRegFgr;
            OleDbConnection cn;
            OleDbCommand cmd;
            OleDbDataReader dr;
            string userid = "", result="";

            if (txtUsernameBuffer.Text == "")
            {
                MessageBox.Show("Please enter your user name.");
                txtUsernameBuffer.Focus();
            }
            else
            {
                try // connect to OfisDemo.mdb
                {
                    cn = new OleDbConnection("Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Jet OLEDB:Database Password=;Data Source='OfisDemo.mdb';Password=;Jet OLEDB:Engine Type=5;Jet OLEDB:Global Bulk Transactions=1;Provider='Microsoft.Jet.OLEDB.4.0';Jet OLEDB:System database=;Jet OLEDB:SFP=False;Extended Properties=;Mode=Share Deny None;Jet OLEDB:New Database Password=;Jet OLEDB:Create System Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;User ID=Admin;Jet OLEDB:Encrypt Database=False");

                    cmd = new OleDbCommand("select id from users", cn); // query all users
                    cn.Open();
                    dr = cmd.ExecuteReader();

                    while (dr.Read())
                    {
                        userid = dr["id"].ToString();
                        if (userid == txtUsernameBuffer.Text)
                            result = txtUsernameBuffer.Text;
                    }

                    if (result != "")
                    {
                        MessageBox.Show("Duplicate User ID. Please insert others ID.");
                    }
                    else
                    {
                        userid = txtUsernameBuffer.Text;
                        axOfisMain2.IsAutoRegister = true;
                        axOfisMain2.CheckFinger = "1000000000";  // left thumb index =1 , right thumb index = 6; set 1=check, 0=uncheck  ; example check left thumb = 1000000000, check right thumb = 0000010000"

                        if (axOfisMain2.Register() == true && userid != "")
                        {
                            lblFingerIndexResult.Text = Convert.ToString(axOfisMain2.FingerIndex);   //register finger index
                            sRegFgr = axOfisMain2.RegisterTemplate;
                            //RegisterUser(txtUsernameBuffer.Text, sRegFgr)

                            if (axOfisMain2.AddRegTemplateToBuffer(FHandle, Convert.ToInt32(userid), sRegFgr) == 0)
                                //  if OfisMain1.AddRegTemplateToBuffer(FpHandle,999999999,sRegFgr) = 0 then
                                listBox1.Items.Add("Register template into buffer failed!");
                            else
                                listBox1.Items.Add("Register template into buffer succesful!");
                        }
                    }
                    cn.Close();
                }
                catch
                { 
                }
            }
        }

        private void btnRemoveIdFromBuffer_Click(object sender, EventArgs e)
        {
            Int32 iUserID = 0;

            if (txtUserIdBuffer.Text == "")
            {
                MessageBox.Show("Please enter your user ID.");
                txtUserIdBuffer.Focus();
            }
            else
            {
                iUserID = Convert.ToInt32(txtUserIdBuffer.Text);
                if (axOfisMain2.RemoveRegTemplateFromBuffer(FHandle, iUserID) == 0)
                    listBox1.Items.Add("Remove ID from buffer failed!");
                else
                    listBox1.Items.Add("Remove ID from buffer succesful!");
            }
        }
        
	}
}
